# Commerce API

Codat's Commerce API enables you to pull up-date-date commerce data from several leading payments, point-of-sale, and eCommerce systems.
You can view your SMB customers' products, orders, payments, payouts, disputes, and more - all standardized to our Commerce data model.

<!-- Start SDK Installation -->
## SDK Installation

```bash
pip install codat-commerce
```
<!-- End SDK Installation -->

## SDK Example Usage
<!-- Start SDK Example Usage -->
```python
import codatcommerce
from codatcommerce.models import operations

s = codatcommerce.CodatCommerce(
    security=shared.Security(
        auth_header="YOUR_API_KEY_HERE",
    ),
)


req = operations.GetCompanyInfoRequest(
    company_id="8a210b68-6988-11ed-a1eb-0242ac120002",
    connection_id="2e9d2c44-f675-40ba-8049-353bfcb5e171",
)

res = s.company_info.get(req)

if res.company_info is not None:
    # handle response
```
<!-- End SDK Example Usage -->

<!-- Start SDK Available Operations -->
## Available Resources and Operations


### [company_info](docs/companyinfo/README.md)

* [get](docs/companyinfo/README.md#get) - Get company info

### [customers](docs/customers/README.md)

* [list](docs/customers/README.md#list) - List customers

### [disputes](docs/disputes/README.md)

* [list](docs/disputes/README.md#list) - List disputes

### [locations](docs/locations/README.md)

* [list](docs/locations/README.md#list) - List locations

### [orders](docs/orders/README.md)

* [list](docs/orders/README.md#list) - List orders

### [payments](docs/payments/README.md)

* [list](docs/payments/README.md#list) - List payments
* [list_methods](docs/payments/README.md#list_methods) - List payment methods

### [products](docs/products/README.md)

* [list](docs/products/README.md#list) - List products
* [list_categories](docs/products/README.md#list_categories) - List product categories

### [tax_components](docs/taxcomponents/README.md)

* [get](docs/taxcomponents/README.md#get) - List tax components

### [transactions](docs/transactions/README.md)

* [list](docs/transactions/README.md#list) - List transactions
<!-- End SDK Available Operations -->

### SDK Generated by [Speakeasy](https://docs.speakeasyapi.dev/docs/using-speakeasy/client-sdks)
